summaryrefslogtreecommitdiffstats
path: root/05-advanced_algorithms_and_complexity/04-np-completeness/check
diff options
context:
space:
mode:
authorJérémy Zurcher <jeremy@asynk.ch>2022-03-29 10:29:56 +0200
committerJérémy Zurcher <jeremy@asynk.ch>2022-03-29 10:29:56 +0200
commit9d34d783c6dc1bda8f0aedfaf19485bbda67938a (patch)
tree99ebae5cfee273c08dcf0197b584df4f83e92bfc /05-advanced_algorithms_and_complexity/04-np-completeness/check
parent0cb72c21cff158fc85a2055d056bdcbb45b1eb21 (diff)
downloadcoursera-9d34d783c6dc1bda8f0aedfaf19485bbda67938a.zip
coursera-9d34d783c6dc1bda8f0aedfaf19485bbda67938a.tar.gz
Algorithms : complete 05-advanced_algorithms_and_complexity 04-np-completenessalgos
Diffstat (limited to '05-advanced_algorithms_and_complexity/04-np-completeness/check')
-rwxr-xr-x05-advanced_algorithms_and_complexity/04-np-completeness/check45
1 files changed, 45 insertions, 0 deletions
diff --git a/05-advanced_algorithms_and_complexity/04-np-completeness/check b/05-advanced_algorithms_and_complexity/04-np-completeness/check
new file mode 100755
index 0000000..796234d
--- /dev/null
+++ b/05-advanced_algorithms_and_complexity/04-np-completeness/check
@@ -0,0 +1,45 @@
+#! /bin/bash
+
+RESET="\033[0m"
+RED="\033[0;31m"
+GREEN="\033[0;32m"
+BROWN="\033[0;33m"
+
+BIN=/tmp/bin
+OUTA=/tmp/_outa
+OUTB=/tmp/_outb
+# GPP_OPTS="-std=c++11 -O0 -ggdb"
+GPP_OPTS="-std=c++11 -O2"
+
+for path in $(find . -name \*.cpp | sort); do
+ src=${path##*/}
+ dir=${path%/*}
+ echo -e "${RED}validate $BROWN$dir$RESET/$GREEN$src$RESET"
+ pushd $dir >/dev/null || exit 1
+ # sed -i 's/^#define DEBUG 1/\/\/ #define DEBUG 1/' $src
+ echo -e " ${RED}compile $GREEN$src$RESET" && g++ $GPP_OPTS $src -o $BIN || exit 1
+ if [ -d tests ]; then
+ start=`date +%s.%N`
+ echo -e " ${RED}check $GREEN$src$RESET"
+ for t in $(find ./tests -name "*[^a~]"|sort); do
+ if [ -f $t -a -f "$t.a" ]; then
+ cat $t | $BIN 2>/dev/null > $OUTA || echo "segfault"
+ cat $t.a > $OUTB
+ cmp $OUTA $OUTB >/dev/null
+ if [ $? -ne 0 ]; then
+ echo -e " $BROWN$t$RESET is ${RED}KO$RESET"
+ cat $OUTA
+ cat $OUTB
+ else
+ echo -e " $BROWN$t$RESET is ${GREEN}ok$RESET"
+ fi
+ fi
+ done
+ end=`date +%s.%N`
+ echo "runtime : $(echo "$end - $start" | bc -l)"
+ else
+ echo -e " ${RED}no tests$RESET"
+ fi
+ popd > /dev/null
+done
+